var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import ReactNumberFormat from 'react-number-format';
import { applyPresentationStrategyToValue, revertPresentationStrategyForValue } from '@reltio/mdm-sdk';
import { getThousandsGroupStyle } from './helpers';
export var NumberFormat = React.forwardRef(function (_a, ref) {
    var onChange = _a.onChange, integer = _a.integer, customInput = _a.customInput, format = _a.format, value = _a.value, otherProps = __rest(_a, ["onChange", "integer", "customInput", "format", "value"]);
    var _b = format || {}, strategy = _b.strategy, groupSize = _b.groupSize, restFormat = __rest(_b, ["strategy", "groupSize"]);
    return (React.createElement(ReactNumberFormat, __assign({}, otherProps, { value: applyPresentationStrategyToValue(strategy, value), thousandsGroupStyle: getThousandsGroupStyle(groupSize) }, restFormat, { getInputRef: ref, isNumericString: true, onValueChange: function (values) {
            onChange({
                target: {
                    value: revertPresentationStrategyForValue(strategy, values.value)
                }
            });
        }, decimalScale: integer ? 0 : undefined, customInput: customInput })));
});
NumberFormat.displayName = 'NumberFormat';
